<%= simple_form_for @rca,
    wrapper: :horizontal_form,
    wrapper_mappings: {
      boolean:       :horizontal_boolean,
      check_boxes:   :horizontal_collection,
      date:          :horizontal_multi_select,
      datetime:      :horizontal_multi_select,
      file:          :horizontal_file,
      radio_buttons: :horizontal_collection,
      range:         :horizontal_range,
      time:          :horizontal_multi_select } do |form| %>
  <%= form.error_notification %>
  <%= form.error_notification message: form.object.errors[:base].to_sentence if form.object.errors[:base].present? %>

  <div class="form-actions" style="padding-bottom: 5px;">
    <%= button_tag type: 'submit', class: "btn btn-outline-warning rca-save-button", name: 'creation_button' do %>
      <%= fa_icon('save', class: 'icon-grey icon-btn icon-margin')+ t('.save') %>
    <% end %>

    <% if Admin::AdminConfig.get_option_attribute(:rca_permit_assoc) %>
      <%= link_to 'Set RCA Reference', rca_add_parent_path(id: @rca.id),
                  remote: true, class: 'btn btn-outline-warning', style: 'float: right;' %>
    <% end %>
  </div>

  <div class="admin-col"><div class="admin-col-content">
    <!-- si tools_rca_list => affiche le RCA de référence -->
    <% if @rca.tools_rca_list&.rca %>
      <%= form.hidden_field :tools_rca_list_id %>
      <div>
        <b>RCA de référence : </b>
        <%= link_to edit_rca_path(@rca.tools_rca_list.rca) do %>
          <%= "#{@rca.tools_rca_list.rca.reference} - #{@rca.tools_rca_list.rca.title}" %>
          <%= fa_icon_edit %>
        <% end %>
        <!-- Delete rca link button -->
        <% if Admin::AdminConfig.get_option_attribute(:rca_permit_assoc) %>
          <%= link_to fa_icon_delete, rca_delete_parent_path(id: @rca.id), method: :delete, class: 'btn', :data => {:confirm => 'Are you sure? This will destroy the link (it will not delete the Rca).'} %>
        <% end %>
      </div>
    <% end %>
    <!-- reference required sauf nouveau rca : id copié dans reference (rca::after_create) si reference est vide -->
    <% if !@rca.new_record? %>
      <% if Admin::AdminConfig.first&.options&.[]('rca_reference_lock') != "true" %>
        <%= form.input :reference, required: true, input_html: { class: 'form-control-sm'} %>
      <% else %>
        <%= form.input :reference, disabled: true, input_html: { class: 'form-control-sm'} %>
      <% end %>
    <% elsif Admin::AdminConfig.first&.options&.[]('rca_reference') != "true" %>
      <%= form.input :reference, required: !@rca.new_record?, input_html: { class: 'form-control-sm'} %>
    <% end %>
    <%= form.input :title, input_html: { class: 'form-control-sm'} %>
    <div class="row" style='margin-top:-10px;'>
      <div class="col-sm-3"></div>
      <div class="col-sm-9">
        <div class="row">
          <div class="col">
            <%= label_tag 'set_cause_title', t('.set_cause_title') %>
            <hr>
          </div>
          <div class="col">
            <%= check_box_tag :set_cause_title, true, false %>
          </div>
        </div>
      </div>
    </div>
    <%#= form.input :created_at, as: :date, html5: true, disabled: true %>
    <% unless @rca.new_record? %>
      <div class="row" style='margin-top:-10px;margin-bottom:15px;'>
        <div class="col-sm-3"><%= Rca.human_attribute_name :created_at %></div>
        <div class="col-sm-9"><%= @rca&.created_at&.to_date %></div>
      </div>
    <% end %>
    <%= input_rca_field_rich_text(form, :description, nil) %>

    <%
      # List des methodo soit (usable = true) soit la methodo du rca
      methodo_collec = Meth::Methodology.rca_methodologies_for_rca(@rca.methodology_id) # @rca.methodology)
    %>
    <%= form.association :methodology, collection: methodo_collec, # Meth::Methodology.rca_methodologies,
                                       include_blank: false,
                                       input_html: { class: 'form-control-sm', 'default-methodo': Admin::AdminConfig.first&.options&.[]('default_methodology') } %>

    <% if @rca.new_record? %>
      <div class="row">
        <div class="col-sm-3"></div>
        <div class="col-sm-9">
          <%= form.button :submit, 'Calcul criticity to choose methodology', name: 'criticity_button', class: 'btn btn-outline-warning' %>
        </div>
      </div>
    <% else %> <!-- Set perimeteres only if rca has been saved -->
      <!-- Perimeters -->
      <div class="form-group row">
        <label class="col-sm-3 col-form-label" for="perimeter_users"><%= Admin::Perimeter.model_name.human.pluralize %></label>
        <div class="col-sm-9">
          <div class='form-control' style='height: auto; max-height: 50px; overflow-y: scroll;'>
            <%= link_to fa_icon_edit, rcas_assign_perimeters_path(id: @rca.id), remote: true %>
            <% @rca.perimeters.each do |perimeter| %>
              <%= perimeter.name %> &nbsp; / &nbsp;
            <% end %>
          </div>
        </div>
      </div>
    <% end %>
  </div></div>

  <%= form.simple_fields_for :custom_field, rca.custom_field do |cf_form| %>
    <% @rca.methodology.step_info.step_tools_with_list.each do |step_tool| %>
      <div class="admin-col">
        <div class="admin-col-title">
          <%= (step_tool.name||step_tool.tool.name) %>
        </div>
        <div class="admin-col-content">
          <% step_tool.tool_custom_fields.each do |tool_custom_field| %>
            <%= input_custom_field(cf_form, rca.custom_field, tool_custom_field.custom_field_desc, obligatory: tool_custom_field.obligatory) %>
          <% end %>
        </div>
      </div>
    <% end %>
  <% end %>

  <div class="form-actions">
    <%= button_tag type: 'submit', class: "btn btn-outline-warning rca-save-button", name: 'creation_button' do %>
      <%= fa_icon('save', class: 'icon-grey icon-btn icon-margin')+ t('.save') %>
    <% end %>
  </div>
<% end %>


<script>
  <% if @rca.new_record? %>
    $(function() {
      function show_hide_rca_submit(select) {
        if ($(select).val() == $(select).attr('default-methodo')) {
          $('input[name=creation_button]').hide();
        }
        else {
          $('input[name=creation_button]').show();
        }
      }

      $('#rca_methodology_id').on('change', function() {
        show_hide_rca_submit(this);
      });

      show_hide_rca_submit('#rca_methodology_id');
    });
  <% end %>

  $(function() {
    function alert_rca_not_saved() {
      $('#btn-edit-rca').css('display', 'none');
      $('#btn-edit-rca-modify').css('display', 'inline');
      $('.rca-save-button').addClass('rca-form-changed')
      console.log("RCA form changed !");
    }

    $("#edit_rca_<%= @rca.id %>").on('change', function() {
      alert_rca_not_saved();
    });

    $('trix-editor').on('trix-change', function() {
      alert_rca_not_saved();
    });


    // $(window).on('beforeunload', function(){
    //   console.log("UNLOAD !!!!!");
    // });

    // window.addEventListener("beforeunload", function(event) {
    //   console.log("UNLOAD:1");
    //   event.returnValue = "Message de test";
    //   //event.preventDefault();
    //   //event.returnValue = null; //"Any text"; //true; //false;
    //   //return null; //"Any text"; //true; //false;
    // });

  });


  // function doSomething(){
  //     //do some stuff here. eg:
  //   console.log("DO SOMETHING !!!!!");
  //   document.getElementById("rca-title").innerHTML="Goodbye!";
  // }
  // function showADialog(e){
  //     var confirmationMessage = 'Your message here';
  //     //some of the older browsers require you to set the return value of the event
  //     (e || window.event).returnValue = confirmationMessage;     // Gecko and Trident
  //     return confirmationMessage;                                // Gecko and WebKit
  // }
  // window.addEventListener("beforeunload", function (e) {
  //     //To do something (Remember, redirects or alerts are blocked here by most browsers):
  //     doSomething();
  //     //To show a dialog (uncomment to test):
  //     //return showADialog(e);
  // });

  // $(function() {
  //   $('[data-role="tagsinput"]').amsifySuggestags({
  //     // suggestionsAction: {
  //     //   url: '<%#= Rails.application.routes.url_helpers.tags_list_path %>'
  //     // }
  //     suggestions: [
  //           {tag: 'Black', value: 1},
  //           {tag: 'White', value: 2},
  //           {tag: 'Red', value: 3},
  //           {tag: 'Blue', value: 4},
  //           {tag: 'Green', value: 5},
  //           {tag: 'Orange', value: 6}
  //         ],
  //     showAllSuggestions: true,
  //     keepLastOnHoverTag: false
  //   })
  //   .on('suggestags.add', function(e){
  //     // Do something after adding tag
  //     console.log("Add tag");
  //   })
  //   .on('suggestags.change', function(e){
  //     // Do something while add/remove tag
  //     console.log("Add tag or remove tag");
  //   })
  //   .on('suggestags.remove', function(e){
  //     // Do something before removing tag
  //     console.log("Remove tag");
  //   });
  // });

</script>
